import ts from 'typescript';
import { Method } from './Method';
import { Modifier } from './Modifier';
import { Property } from './Property';
import { TypeParameter } from './TypeParameter';
interface IMightBeOptional {
    questionToken?: ts.Token<ts.SyntaxKind.QuestionToken>;
}
export declare function isNodeExported(node: ts.Node): boolean;
export declare function getModifier(modifiers: ts.NodeArray<ts.Modifier>): Modifier;
export declare function getExtendsHeritageClauseName(heritageClause: ts.HeritageClause): string;
export declare function getInterfaceName(nodeObject: ts.ExpressionWithTypeArguments): string;
export declare function getImplementsHeritageClauseNames(heritageClause: ts.HeritageClause): string[];
export declare function isMethod(declaration: ts.NamedDeclaration): boolean;
export declare function isProperty(declaration: ts.NamedDeclaration): boolean;
export declare function isTypeParameter(declaration: ts.NamedDeclaration): boolean;
export declare function getMemberModifier(memberDeclaration: ts.Declaration): 'public' | 'private' | 'protected';
export declare function isAbstract(memberDeclaration: ts.Declaration): boolean;
export declare function isStatic(memberDeclaration: ts.Declaration): boolean;
export declare function serializeMethods(memberSymbols: ts.UnderscoreEscapedMap<ts.Symbol>, checker: ts.TypeChecker): (Property | Method)[];
export declare function serializeTypeParameters(memberSymbols: ts.UnderscoreEscapedMap<ts.Symbol>, checker: ts.TypeChecker): TypeParameter[];
export declare function hasInitializer(declaration: ts.ParameterDeclaration): boolean;
export declare function isOptional(declaration: IMightBeOptional): boolean;
export {};
